C*******************************************************************************

      INTEGER*4  FUNCTION  add_routine (name, source_type)

C*******************************************************************************
C
C      Function ADD_ROUTINE adds a routine to the routine table.  If the
C      routine has already been entered in the table, the index of the
C      existing entry is returned to the calling program.  Otherwise,
C      a new entry is made and its index is returned.
C
C
C      Arguments:
C
C          NAME  (Character)
C              is the name of the routine to add.
C          SOURCE_TYPE  (Character)
C              is the source of the symbol definition; possible values are
C              specified in the STRUCHART.INC include file.  SOURCE_TYPE
C              should be blank (' ') if this instance of the routine name
C              is simply a reference (i.e., it occurs on the right side of
C              the <x>-calls-<y> relation) and not a definition.
C          ADD_ROUTINE  (Function Value)
C              returns the index of the routine in the routine table.
C
C*******************************************************************************

      IMPLICIT  NONE

C...      Parameters, global variables, and external definitions.

      INCLUDE  'struchart.inc'                  ! STRUCHART parameters and data structures.

C...      Function argument.

      CHARACTER*(*)  name
      CHARACTER*(*)  source_type

C...      Local variables.

      INTEGER*4  index
      LOGICAL  found





C...      Search the table for the name of the routine.

      found = .FALSE.
      index = 0
      DO WHILE ((.NOT. found) .AND. (index .LT. num_routines))
          index = index + 1
          IF (routine_name(index) .EQ. name)  found = .TRUE.
      ENDDO

C...      If found, return the index of the routine in the table.
C      If not found, add the routine to the table and return its index.

      IF (.NOT. found) THEN
          IF (num_routines .LT. MAX_NUM_ROUTINES) THEN
              index = num_routines + 1
              routine_name(index) = name
              calls(index) = NULL                       ! Initialize adjacency lists.
              called_by(index) = NULL
              defined_in(index) = ' '
              in_degree(index) = 0
              num_routines = index
          ELSE
              WRITE (6,*)  '** Number of routines in call graph ' //
     +                     'exceeds ', MAX_NUM_ROUTINES, '. **'
              CALL EXIT
          ENDIF
      ENDIF


      IF (defined_in(index) .EQ. ' ')  defined_in(index) = source_type

      add_routine = index


      RETURN


      END
