C**************************************************************************

      SUBROUTINE  read_obj (file_name)

C**************************************************************************
C
C      Subroutine READ_OBJ reads records from an object file and passes
C      them to GET_SYMBOLS for processing.
C
C
C      Arguments:
C
C          FILE_NAME  (Character)
C              is the name of the object file to be read.
C
C**************************************************************************


      IMPLICIT  NONE

C...      Parameters, global variables, and external definitions.

      INCLUDE '($OBJRECDEF)'    ! Object language record definition.
      PARAMETER  P_OBJ_LUN = 7  ! Logical unit number for object file.
      INTEGER*4  trim           ! External function.

C...      Subroutine arguments.

      CHARACTER*(*)  file_name

C...      Local variables.

      CHARACTER  buffer*(OBJ$C_MAXRECSIZ), current_module*32
      CHARACTER  extension*4, message*128, object_file*128
      INTEGER*4  length, status





C...      Derive the object file name (i.e., if a non-'.OBJ' file was
C      specified) and open the file.

      CALL fparse (file_name, , , %DESCR('TYPE'), , extension)
      IF (extension .EQ. '.OBJ') THEN
          object_file = file_name       ! Preserve version number.
      ELSE
          CALL fparse (%DESCR('.OBJ;'), file_name, , , , object_file)
      ENDIF

      message = 'Error opening object file: "' //
     +          object_file(1:trim(object_file)) // '"'
      OPEN (UNIT=P_OBJ_LUN, NAME=object_file, TYPE='OLD', READONLY,
     +      ACCESS='SEQUENTIAL', FORM='FORMATTED',
     +      RECORDTYPE='VARIABLE', ERR=900)


C...      While not EOF, read and process a record from the object file.

      current_module = ' '
      message = 'Error reading object file: "' //
     +          object_file(1:trim(object_file)) // '"'

      DO WHILE (.TRUE.)

          READ (P_OBJ_LUN,400,END=50,ERR=900)  length, buffer(1:length)
400       FORMAT (Q, A)

          CALL get_symbols (current_module, 'OBJ', %REF(buffer), length)

      ENDDO     ! Until EOF.


50    CLOSE (UNIT=P_OBJ_LUN)


      RETURN





C...      Error return.

900   CALL ERRSNS ( , , , , status)
      WRITE (6,*)  message(1:trim(message))
      CALL LIB$SYS_GETMSG (status, length, message, , )
      WRITE (6,*)  message(1:length)

      CLOSE (UNIT=P_OBJ_LUN)

      RETURN


      END
