C**************************************************************************

      INTEGER*4  FUNCTION  read_olb (key, rfa)

C**************************************************************************
C
C      Function READ_OLB is automatically invoked by LBR$GET_INDEX (see
C      SCAN_OLB.FOR) to read each object module in a library.  READ_OLB
C      simply reads each record from the object module and calls GET_SYMBOLS
C      to extract module calling relations.
C
C
C      Arguments:
C
C          KEY  (Character)
C              Supplied by LBR$GET_INDEX, this is the key (i.e., the name)
C              of the object module in the library.
C          RFA  (Integer Array)
C              Supplied by LBR$GET_INDEX, this is the file address of the
C              object module header record.
C          READ_OLB  (Function Value)
C              Returns the status of reading the object module to
C              LBR$GET_INDEX.  If an abnormal status is received,
C              LBR$GET_INDEX terminates its library scan.  READ_OLB
C              always returns a normal status, unless it has trouble
C              positioning to the start of an object module.
C
C**************************************************************************


      IMPLICIT  NONE

C...      Parameters, global variables, and external definitions.

      INCLUDE '($DSCDEF)'       ! Descriptor type definitions.
      INCLUDE '($SSDEF)'        ! System service failure and status codes.
      INCLUDE 'struchart.inc'   ! Object library handle.
      INTEGER*4  trim           ! External functions.
      INTEGER*4  LBR$FIND, LBR$GET_RECORD

C...      Subroutine arguments.

      CHARACTER*(*)  key
      INTEGER*4  rfa(2)

C...      Local variables.

      CHARACTER  current_module*32, message*128
      INTEGER*4  length, status
      RECORD /DSCDEF1/  object_record




C...      Position to the beginning of the object module and read each
C      of the records in the module.  Each record is passed to GET_SYMBOLS
C      for symbol extraction.  NOTE that the records are retrieved in
C      LOCATE mode (see SCAN_OLB and LBR$SET_LOCATE).

      current_module = ' '

      status = LBR$FIND (olb_handle, rfa)
      IF (.NOT. status) THEN
          WRITE (6,*)  'Error positioning to library module: "',
     +                 key(1:trim(key)), '"'
          CALL LIB$SYS_GETMSG (status, length, message, , )
          WRITE (6,*)  message(1:length)
          read_olb = status     ! Abort scan.
          RETURN
      ENDIF

      WRITE (6,*)  '    ', key(1:trim(key))

      DO WHILE (status)
          status = LBR$GET_RECORD (olb_handle, , object_record)
          length = object_record.DSC$W_MAXSTRLEN
          IF (status)  CALL get_symbols (current_module, 'OLB',
     +                                %VAL(object_record.DSC$A_POINTER),
     +                                   length)
      ENDDO

      read_olb = SS$_NORMAL     ! Continue scan.

      RETURN


      END
