C*******************************************************************************

      SUBROUTINE  read_sci (file_name)

C*******************************************************************************
C
C      Subroutine READ_SCI reads a STRUCHART intermediate file, which has
C      the following format (more or less - it's free format):
C
C                 "Routine <module_name_1> Calls
C                        <global_symbol_1>
C                        <global_symbol_2>
C                        ...
C                        <global_symbol_N>"
C                  Routine <module_name_2> Calls
C                  ..."
C
C      and stores the calling hierarchy information in the call graph
C      data structures.
C
C
C      Arguments:
C
C          FILE_NAME  (Character)
C              is the name of the intermediate file to be read.
C
C*******************************************************************************

      IMPLICIT  NONE

C...      Parameters, global variables, and external definitions.

      INCLUDE  'struchart.inc'          ! STRUCHART definitions.
      PARAMETER  TAB = CHAR (9)
      PARAMETER  P_SCI_LUN = 8          ! Logical unit number for intermediate file.
      INTEGER*4  add_routine, trim      ! External functions.

C...      Subroutine arguments.

      CHARACTER  file_name*(*)

C...      Local variables.

      CHARACTER  delimiters*2, message*128, text*128, word*32
      INTEGER*4  calling_routine, first, last, length
      INTEGER*4  ptr, start, status
      LOGICAL  is_caller


      delimiters = ' ' // TAB


C...      While not EOF on the structure chart intermediate file, build
C      the routine list and the graph of the program's calling structure.

      message = 'Error opening intermediate file: "' //
     +          file_name(1:trim(file_name)) // '"'
      OPEN (UNIT=P_SCI_LUN, NAME=file_name, TYPE='OLD', READONLY,
     +      ERR=900)

      message = 'Error reading intermediate file: "' //
     +          file_name(1:trim(file_name)) // '"'
      is_caller = .TRUE.


      DO WHILE (.TRUE.)         ! While not EOF.

          READ (P_SCI_LUN,400,END=10,ERR=900)  text
400       FORMAT (A)

          start = 1
          CALL getword (text, start, delimiters, first, last, length)

          DO WHILE (length .GT. 0)

              CALL STR$UPCASE (word, text(first:last))

              IF (word .EQ. 'ROUTINE') THEN
                  is_caller = .TRUE.
              ELSEIF (word .EQ. 'CALLS') THEN
                  is_caller = .FALSE.
              ELSE
                  IF (is_caller) THEN           ! Routine X calls ...?
                      ptr = add_routine (text(first:last), 'SCI')
                      calling_routine = ptr
                      is_caller = .FALSE.
                  ELSE                          ! ... calls routine Y?
                      ptr = add_routine (text(first:last), ' ')
                      CALL add_node (calling_routine, ptr)
                  ENDIF
              ENDIF

              start = last + 1
              CALL getword (text, start, delimiters,
     +                      first, last, length)

          ENDDO     ! For each word in the line.

      ENDDO     ! While not EOF.


10    CONTINUE

      CLOSE (UNIT=P_SCI_LUN)

      RETURN





C...      Error return.

900   CALL ERRSNS ( , , , , status)
      WRITE (6,*)  message(1:trim(message))
      CALL LIB$SYS_GETMSG (status, length, message, , )
      WRITE (6,*)  message(1:length)

      CLOSE (UNIT=P_SCI_LUN)

      RETURN


      END
