C**************************************************************************

      SUBROUTINE  scan_olb (file_name)

C**************************************************************************
C
C      Subroutine SCAN_OLB scans the object modules in a ".OLB" library
C      file.  SCAN_OLB opens the library file and then calls a system
C      routine, LBR$GET_INDEX, to perform the actual scan.  LBR$GET_INDEX
C      scans the library and calls READ_OLB for each object module found.
C      READ_OLB, in turn, calls GET_SYMBOLS to extract calling hierarchy
C      information.
C
C
C      Arguments:
C
C          FILE_NAME  (Character)
C              is the name of the object library to read.
C
C**************************************************************************


      IMPLICIT  NONE

C...      Parameters, global variables, and external definitions.

      INCLUDE '($LBRDEF)'       ! Library type definitions.
      INCLUDE 'struchart.inc'   ! Object library handle.
      INTEGER*4  trim           ! External functions.
      INTEGER*4  LBR$GET_INDEX, LBR$INI_CONTROL
      INTEGER*4  LBR$OPEN, LBR$SET_LOCATE
      EXTERNAL  read_olb

C...      Subroutine arguments.

      CHARACTER  file_name*(*)

C...      Local variables.

      CHARACTER  message*128
      INTEGER*4  length, status




C...      Allocate and initialize a control structure for the library
C      scan, open the library, and set the record access mode to "LOCATE"
C      (so that LBR$GET_RECORD need only return a pointer to a record,
C      rather than copying the record into a user buffer).

      message = 'Error opening object library: "' //
     +          file_name(1:trim(file_name)) // '"'

      status = LBR$INI_CONTROL (olb_handle, LBR$C_READ)
      IF (.NOT. status)  GOTO 900

      status = LBR$OPEN (olb_handle, file_name)
      IF (.NOT. status)  GOTO 900

      status = LBR$SET_LOCATE (olb_handle)
      IF (.NOT. status)  GOTO 900


C...      Use a system routine, LBR$GET_INDEX, to scan the library and
C      call subroutine READ_OLB for each object file found.

      message = 'Error scanning object library: "' //
     +          file_name(1:trim(file_name)) // '"'
      status = LBR$GET_INDEX (olb_handle, 1, read_olb)
      IF (.NOT. status)  GOTO 900


C...      Close the library.

      CALL LBR$CLOSE (olb_handle)


      RETURN





C...      Error return.

900   WRITE (6,*)  message(1:trim(message))
      CALL LIB$SYS_GETMSG (status, length, message, , )
      WRITE (6,*)  message(1:length)

      CALL LBR$CLOSE (olb_handle)

      RETURN


      END
