C*******************************************************************************

      INTEGER*4  FUNCTION  trim (string)

C*******************************************************************************
C
C      Function TRIM trims trailing blanks, tabs, and null characters from
C      a string and returns the resulting length.  For example, given a
C      string with trailing spaces, '12345   ', TRIM would return a length
C      of 5.  "STRING(1:TRIM(STRING))" can be used to reference a string
C      with trailing white space excluded.
C
C
C      Arguments:
C
C          STRING  (Character)
C              The character string to be trimmed.
C          TRIM  (Function Value)
C              Returns the length of STRING with trailing blanks, tabs,
C              and null characters removed.
C
C*******************************************************************************

      IMPLICIT NONE

C...      Parameters and external definitions.

      PARAMETER  NULL = CHAR (0)
      PARAMETER  TAB = CHAR (9)

C...      Subroutine arguments.

      CHARACTER  string*(*)

C...      Local variables.

      INTEGER*4  i




      DO i = LEN (string), 1, -1
          IF ((string(i:i) .NE. ' ') .AND.
     +        (string(i:i) .NE. TAB) .AND.
     +        (string(i:i) .NE. NULL)) THEN
              trim = i
              RETURN
          ENDIF
      ENDDO

      trim = LEN (string)

      RETURN


      END
